UI::Font@ font = null;
int fontFace = 0;
uint MAX_INT = 4294967295;
uint mapCheckpointCount = MAX_INT;
MwFastBuffer<int> currCheckpointTimes = MwFastBuffer<int>();
uint currentCheckpoint = 0;
uint currentCPCount = 0;
uint lapTime2Display = 0;
uint runTime2Display = 0;
uint fastestLap2Display = 0;
uint fastestRun2Display = 0;
int epochTimerSplits = 0;
int epochTimerLap = 0;
int currentCPSplit = 0;
int previousRunSplit = 0;
int bestRunSplit = 0;
int previousLapSplit = 0;
int currentLap = 0;
int[] indexToDisplayDownloaded = int[]();
int[] indexToDisplayMedals = {};
int[] indexToDisplayTotal = {};
int totalGhostIndexs = -1;
bool checkedGhosts = false;
bool replayLoaded = false;
bool lapStarted = false;
bool addedThisFinish = false;
bool replayListAll = false;
bool userSelectedReplay = false;
bool autoDetectEnabled = false;
bool isPlayingOnline = false;
bool modeIsTimeAttack = false;
bool firstTimeLoadMapNoPB = false;
bool newLap = false;
bool showLapTime = false;
int selectedIndex = -1;
int selectedDediIndex = -1;
int selectedSTMIndex = -1;
int newLapStartIndex = -1;
string previousGhostName = "";
CGameGhostStriped[]@ previousRunTimes = {};
int[] selectedReplayCPs;
bool onlineDediChecked = false;
bool noDediLoaded = false;
int[][] dediReplayCPs = {{}, {}, {}}; // 0 = TA, 1 = Rounds, 2 = WR
string[] dedimaniaLogins = {'Unloaded', 'Unloaded', 'Unloaded'};
int autoDetectedGhost = -1;
string currentMapUID = "";
bool mapChanged = false;
CGameGhostStriped@ loadedGhost = CGameGhostStriped();
bool isCPLap = false;
int ghostCountStartTM2020 = 0;
int raceUITimerIndex = -1;
bool recountGhosts = true;
bool disableForOnlineMultilap = false;

int[] lapTimesCount;

#if TMNEXT
const MLFeed::HookRaceStatsEventsBase_V4@ raceData;
const MLFeed::PlayerCpInfo_V4@ player;
#endif


void RenderMenu() {
    if(UI::MenuItem("\\$08f" + Icons::Refresh + "\\$z Change Replay", "", replayListAll)) {
		replayListAll = !replayListAll;
	}
}



string GetRoundPosition() {
    int position = 1;
#if MP4
    for (uint i = 1; i < GetApp().CurrentPlayground.Players.Length; i++) {
        CTrackManiaPlayer@ player = cast<CTrackManiaPlayer@>(GetApp().CurrentPlayground.Players[i]);
        CTmRaceResultNod@ results = cast<CTmRaceResultNod@>(player.ScriptAPI.CurRace);
        if (results.Time != -1) {
            MwFastBuffer<int> playerCPs = results.Checkpoints;
            if (playerCPs.Length != 0 && currCheckpointTimes.Length != 0) {
                if (playerCPs.Length > currCheckpointTimes.Length) position++;
                if (playerCPs.Length == currCheckpointTimes.Length) {
                    if (playerCPs[currCheckpointTimes.Length - 1] < currCheckpointTimes[currCheckpointTimes.Length - 1]) position++;
                }
            }
        }
    }
#elif TMNEXT
    auto allPlayers = raceData.SortedPlayers_Race;
    auto playerCPs = player.CpTimes;

    if (GetRaceState() == 0) return '';
    for (uint i = 0; i < allPlayers.Length; i++) {
        if (allPlayers[i].IsLocalPlayer) continue;

        if (!IsModeRounds()) {
            auto playerResult = allPlayers[i].BestRaceTimes;
            if ((!playerResult.IsEmpty() && playerCPs.Length != 0) && int(playerResult[playerCPs.Length - 2]) < playerCPs[playerCPs.Length - 1]) {position++;}
        } else {
            auto playerResult = allPlayers[i].CpTimes;
            if (playerResult.Length > playerCPs.Length) position++;
            if (playerResult.Length == playerCPs.Length) {
                if (playerResult[playerCPs.Length - 2] < playerCPs[playerCPs.Length - 1]) position++;
            }
        }
    }
#endif
    return GeneratePositionText(position);
}

string GeneratePositionText(int position) {
    if (position % 10 == 1 && (Math::Floor(position / 10) % 10) != 1) return position + 'st';
    else if (position % 10 == 2 && (Math::Floor(position / 10) % 10) != 1) return position + 'nd';
    else if (position % 10 == 3 && (Math::Floor(position / 10) % 10) != 1) return position + 'rd';
    else return position + 'th';
}

#if MP4
Net::HttpRequest@ GetRequest(const string &in link) {
    Net::HttpRequest@ request = Net::HttpGet(link);
    while (!request.Finished()) {
		yield();
	}
    return request;
}



void GetDediCPs() {
    auto rootMap = GetApp().RootMap;
    int[][] tempArray;
    string rootMapuId = rootMap.EdChallengeId;
    string collection = rootMap.CollectionName;
    while (rootMap.TMObjective_IsLapRace && GetPlayer() !is null && !GetPlayer().IsSpawned) yield();
    bool allowRoundsMultilap = (rootMap.TMObjective_IsLapRace && cast<CTrackManiaRaceNew@>(GetApp().CurrentPlayground).LapCount == rootMap.TMObjective_NbLaps) || !rootMap.TMObjective_IsLapRace;
    if (disableForOnlineMultilap) {dediReplayCPs = {{}, {}, {}}; return;}

    // User TA Dedimania record
    if (!rootMap.TMObjective_IsLapRace) tempArray.InsertLast(StripHTMLDedimania(GetRequest("http://dedimania.net/tm2stats/?do=stat&Envir=" + collection + "&UId=" + rootMapuId + "&Login=" + GetLocalLogin() + "&Mode=M2&Show=RECORD"), 0));
    else tempArray.InsertLast({});
    
    // User Rounds Dedimania record
    if (tempArray[0].Length == 0 && allowRoundsMultilap) tempArray.InsertLast(StripHTMLDedimania(GetRequest("http://dedimania.net/tm2stats/?do=stat&Envir=" + collection + "&UId=" + rootMapuId + "&Login=" + GetLocalLogin() + "&Mode=M1&Show=RECORD"), 1));
    else tempArray.InsertLast({});

    // WR Dedimania record
    string modeType = rootMap.TMObjective_IsLapRace ? "M1" : "M2";
    if (!allowRoundsMultilap) tempArray.InsertLast({});
    else {
        tempArray.InsertLast(StripHTMLDedimania(GetRequest("http://dedimania.net/tm2stats/?do=stat&Envir=" + collection + "&UId=" + rootMapuId + "&Mode=" + modeType + "&Show=RECORD&Limit=1"), 2));
        if (dedimaniaLogins[2] != 'Unloaded') {
            dedimaniaLogins[2] = StripHTMLDedimaniaNickName(GetRequest("http://dedimania.net/tm2stats/?do=stat&Login=" + dedimaniaLogins[2] + "&Envir=" + collection + "&Show=RECORDS&Limit=1"), 2);
        }
    }
    dediReplayCPs = tempArray;
}



string StripHTMLDedimaniaNickName(Net::HttpRequest@ request, int userLoginIndex) {
    if (request.ResponseCode() == 200) {
        string response = request.String();
        string[] stringToReplace = Regex::Search(response, '<td height="20" bgcolor="#FFFFFF">.+</td>');
        if (stringToReplace.Length != 0) response = response.Replace(stringToReplace[0], '');
        string[] matchesName = Regex::Search(response, '<td height="20" bgcolor="#FFFFFF">.+</td>');

        if (matchesName.Length != 0) {
            string replacedText = Regex::Replace(matchesName[0], '<td height="20" bgcolor="#FFFFFF">|</td>', '');
            return Regex::Replace(replacedText, '<a class=\'tabl\' href=\'.*\'>|</a>', '');
        }
    }
    return dedimaniaLogins[userLoginIndex];
}



int[] StripHTMLDedimania(Net::HttpRequest@ request, int userLoginIndex) {
    if (request.ResponseCode() == 200) {
        string response = request.String();
        string[] stringToReplace = Regex::Search(response, '<td height="20" bgcolor="#FFFFFF">.+</td>');
        if (stringToReplace.Length != 0) response = response.Replace(stringToReplace[0], '');
        string[] matchesName = Regex::Search(response, '<td height="20" bgcolor="#FFFFFF">.+</td>');
        string[] matchesCPs = Regex::Search(response, '<td height="20" bgcolor="#FFFFFF">([0-9]+,)+[0-9]+</td>');
        if (matchesCPs.Length == 0) matchesCPs = Regex::Search(response, '<td height="20" bgcolor="#FFFFFF">([0-9]+,)?[0-9]+</td>');

        if (matchesCPs.Length != 0 && matchesName.Length != 0) {
            string recordLogin = Regex::Replace(matchesName[0], '<td height="20" bgcolor="#FFFFFF">|</td>', '');
            string[] splitCPTimes = Regex::Replace(matchesCPs[0], '<td height="20" bgcolor="#FFFFFF">|</td>', '').Split(',');
            int[] cpTimes;
            for (uint i = 0; i < splitCPTimes.Length; i++) {cpTimes.InsertLast(Text::ParseInt(splitCPTimes[i]));}
            dedimaniaLogins[userLoginIndex] = recordLogin;
            return cpTimes;
        }
    } else dedimaniaLogins[userLoginIndex] = 'Unloaded';
    return {};
}



bool DedimaniaAvailableToUse() {
    if (Setting_PrioritizeWRDedi && dediReplayCPs[2].Length != 0) return true;
    if (!Setting_PrioritizeWRDedi && (dediReplayCPs[1].Length != 0 || dediReplayCPs[0].Length != 0)) return true;
    return false;
}
#endif



bool UseDedimania() {
#if MP4
    return ((!isPlayingOnline && ((selectedDediIndex == -1 && !Setting_DediSoloEnable) || selectedIndex != -1)) && Setting_PrioritizeDediOffline) || 
            (!Setting_PrioritizeDediOffline && selectedDediIndex == -1 && !isPlayingOnline) ||
            (Setting_PrioritizeDediOffline && Setting_PrioritizeDediOfflineNadeo && !isPlayingOnline && GetApp().RootMap.AuthorLogin == 'Nadeo' && selectedDediIndex == -1) ||
            (!DedimaniaAvailableToUse() && GetApp().PlaygroundScript !is null);
#elif TURBO || TMNEXT
    return true;
#endif
}



CGameManiaPlanetScriptAPI@ GetManiaplanetAPI() {
    CGameManiaPlanet@ mp = cast<CGameManiaPlanet>(GetApp());
    return cast<CGameManiaPlanetScriptAPI>(mp.ManiaPlanetScriptAPI);
}



bool MapEditorInvalid() {
    if (GetApp().Editor is null) return false;
    CGameCtnEditorCommon@ itemCursor = cast<CGameCtnEditorCommon@>(GetApp().Editor);
    if (itemCursor is null) return true;
    return itemCursor.ItemCursor !is null;
}



void Render() {
    auto rootMap = GetRootMap();
    if ((GetApp().CurrentPlayground is null && GetApp().PlaygroundScript is null) || rootMap is null || MapEditorInvalid()) {
        mapCheckpointCount = MAX_INT;
        currCheckpointTimes = MwFastBuffer<int>();
        currentCheckpoint = 0;
        lapTime2Display = 0;
        runTime2Display = 0;
        fastestLap2Display = 0;
        fastestRun2Display = 0;
        currentCPSplit = 0;
        previousRunSplit = 0;
        bestRunSplit = 0;
        previousLapSplit = 0;
        checkedGhosts = false;
        replayLoaded = false;
        lapStarted = false;
        previousGhostName = "";
        previousRunTimes = {};
        selectedIndex = -1;
        selectedDediIndex = -1;
        selectedSTMIndex = -1;
        newLapStartIndex = -1;
        firstTimeLoadMapNoPB = false;
        epochTimerSplits = 0;
        epochTimerLap = 0;
        currentCPCount = 0;
        newLap = false;
        showLapTime = false;
        onlineDediChecked = false;
        noDediLoaded = false;
        replayListAll = false;
        dediReplayCPs = {{}, {}, {}};
        dedimaniaLogins = {'Unloaded', 'Unloaded', 'Unloaded'};
        totalGhostIndexs = -1;
        autoDetectedGhost = -1;
        currentMapUID = "";
        mapChanged = false;
        loadedGhost = CGameGhostStriped();
        raceUITimerIndex = -1;
        userSelectedReplay = false;
        indexToDisplayDownloaded = {};
        indexToDisplayMedals = {};
        indexToDisplayTotal = {};
        recountGhosts = true;
        disableForOnlineMultilap = false;
#if TMNEXT
        @raceData = null;
        @player = null;
#endif
        return; 
    }

#if TMNEXT
    if (raceData is null || player is null) {
        @raceData = MLFeed::GetRaceData_V4();
        @player = raceData.GetPlayer_V4(MLFeed::LocalPlayersName);
        return;
    }
#endif


    if (currentMapUID != rootMap.EdChallengeId) {currentMapUID = rootMap.EdChallengeId; mapChanged = true;}
    if (mapCheckpointCount == MAX_INT && IsSpawned()) mapCheckpointCount = GetCPCount();
    CGameManiaPlanetScriptAPI@ mpAPI = GetManiaplanetAPI();
    isPlayingOnline = (GetApp().CurrentPlayground !is null && mpAPI.CurrentServerLogin != '') ? true : false;
    
    // Checks if script is TA for multilap tracks
    if (isPlayingOnline) {modeIsTimeAttack = mpAPI.CurrentServerModeName == 'TimeAttack';}
    if (GetApp().PlaygroundScript is null && !isPlayingOnline) {return;}

    GetGhost();
    RenderHoloHUD();
    runGUI();
    runGUIReplayList();
    UpdateRunSplit();
    isCPLap = false;

    if ((GetRaceState() == 0 || autoDetectedGhost == -1 || totalGhostIndexs == -1) && !isPlayingOnline) {
        if (!checkedGhosts || autoDetectedGhost == -1) {
            if (GetApp().PlaygroundScript !is null) {
#if MP4 || TMNEXT
                auto dataFileMgr = GetDataMgr();
                auto ghostLengthCondition = int(dataFileMgr.Ghosts.Length) != totalGhostIndexs;
#elif TURBO
                auto dataFileMgr = GetDataMgr();
                bool ghostLengthCondition = true;
#endif
                if (ghostLengthCondition || autoDetectedGhost == -1) {
                    autoDetectedGhost = GetLocalPBRecord();
                    totalGhostIndexs = dataFileMgr.Ghosts.Length;
                    GenerateReplayCategories();
                }
                checkedGhosts = true;
            }
        } 
    }

#if TMNEXT
    if (IsSpawned() && recountGhosts) {
        if (GetApp().Network.ClientManiaAppPlayground is null || GetApp().Network.ClientManiaAppPlayground.DataFileMgr.Ghosts.Length == 0) ghostCountStartTM2020 = 0;
        else ghostCountStartTM2020 = !IsModeRounds() ? GetApp().Network.ClientManiaAppPlayground.DataFileMgr.Ghosts.Length - 1 : 0;
        recountGhosts = false;
    }
#endif


    if (GetRaceState() == 1 && IsSpawned()) {
        checkedGhosts = false;
        currCheckpointTimes = GetPlayerCPs();
        uint cpTime = GetCPTime();
        if (cpTime != currentCheckpoint && cpTime > 0 && cpTime != MAX_INT) {
            currentCheckpoint = cpTime;

            if (IsMapMultilap() && cpTime > 0) {
                // First lap
                if (mapCheckpointCount != MAX_INT && GetLapValue() <= 1 && currCheckpointTimes.Length == mapCheckpointCount) {lapTime2Display = currentCheckpoint; previousLapSplit = fastestLap2Display != 0 ? lapTime2Display - fastestLap2Display : 0; isCPLap = true;}

                // Second lap and above
                else if (mapCheckpointCount != MAX_INT && GetLapValue() > 1 && (currCheckpointTimes.Length - mapCheckpointCount) % (mapCheckpointCount) == 0) {
                    lapTime2Display = currentCheckpoint - currCheckpointTimes[currCheckpointTimes.Length - mapCheckpointCount - 1]; 
                    previousLapSplit = lapTime2Display - fastestLap2Display; 
                    isCPLap = true;
                }
            }
        }
        addedThisFinish = false;
    }

    if (GetRaceState() == 2) {UpdateSplits();}

    if (isCPLap) {
        if (lapTime2Display < fastestLap2Display && fastestLap2Display != 0) {fastestLap2Display = lapTime2Display;}
        else if (fastestLap2Display == 0) {fastestLap2Display = currentCheckpoint;}
        newLapStartIndex = currCheckpointTimes.Length - 1;
    }

    if ((GetRaceState() == 2 || GetRaceState() == 0) && currCheckpointTimes.Length > 0) {
        currentCheckpoint = 0;
        currCheckpointTimes = MwFastBuffer<int>();
        currentCPSplit = 0;
    }

    selectedReplayCPs = loadedGhost.checkpoints;
    autoDetectEnabled = false;
}



void Main()
{
    @font = UI::LoadFont("DroidSans.ttf", Setting_FontSize, -1, -1, true, true, true);
    fontFace = nvg::LoadFont("DroidSans-Bold.ttf");

#if MP4
    while (true) {
        if ((GetApp().CurrentPlayground !is null && GetPlayer() !is null) && GetRootMap() !is null) {
            if (isPlayingOnline && !onlineDediChecked && !Setting_DediSoloEnable && mapChanged) {
                GetDediCPs();
                onlineDediChecked = true;
                mapChanged = false;
            }
            if (!onlineDediChecked && Setting_DediSoloEnable && mapChanged) {
                GetDediCPs();
                onlineDediChecked = true;
                mapChanged = false;
            }
        }
        yield();
    }
#endif
}



void UpdateSplits() {
    auto rootMap = GetRootMap();
    if (mapCheckpointCount != MAX_INT && currCheckpointTimes.Length != 0 && (IsMapMultilap())) {
        currCheckpointTimes = GetPlayerCPs();
        if ((currCheckpointTimes.Length - mapCheckpointCount - 1) < 0 || (currCheckpointTimes.Length - mapCheckpointCount - 1) >= currCheckpointTimes.Length) return;
        lapTime2Display = currCheckpointTimes[currCheckpointTimes.Length - 1] - currCheckpointTimes[currCheckpointTimes.Length - mapCheckpointCount - 1];
        previousLapSplit = lapTime2Display - fastestLap2Display; 
        isCPLap = true;
    }

    uint finishTimer = GetCPTime(true);
    if (finishTimer != MAX_INT && finishTimer != 0) {
        if (!addedThisFinish && runTime2Display != finishTimer) {
            bool isReplayAdded = false;
            for (uint i = 0; i < previousRunTimes.Length; i++) {
                if (uint(previousRunTimes[i].raceTime) == finishTimer) {isReplayAdded == true;}
            }
            if (!isReplayAdded) {previousRunTimes.InsertLast(CreateGhost(GetPlayerName(), finishTimer, currCheckpointTimes));}
            addedThisFinish = true;
        }
        runTime2Display = finishTimer;

        if (runTime2Display < fastestRun2Display && fastestRun2Display != 0) {fastestRun2Display = runTime2Display;}
        else if (fastestRun2Display == 0) {fastestRun2Display = runTime2Display;}

        previousRunSplit = runTime2Display - loadedGhost.raceTime;
        bestRunSplit = fastestRun2Display - loadedGhost.raceTime;
    }
}



void UpdateRunSplit() {
    if (GetPlayer() is null) return;
    auto rootMap = GetRootMap();
    if (currCheckpointTimes.Length > 0 && selectedReplayCPs.Length > 0 && currCheckpointTimes.Length <= selectedReplayCPs.Length && replayLoaded) {
#if MP4 || TURBO
        if (isPlayingOnline && modeIsTimeAttack && (IsMapMultilap()) && GetLapValue() != 0) {
            currentCPSplit = ((GetPlayer().CurCheckpointLapTime != MAX_INT ? GetPlayer().CurCheckpointLapTime : 0) - selectedReplayCPs[((currCheckpointTimes.Length - 1) % mapCheckpointCount)]);
        } else {currentCPSplit = currCheckpointTimes[currCheckpointTimes.Length-1] - selectedReplayCPs[currCheckpointTimes.Length-1];}
#elif TMNEXT
        currentCPSplit = currCheckpointTimes[currCheckpointTimes.Length-1] - selectedReplayCPs[currCheckpointTimes.Length-1];
#endif
    } else {replayLoaded = false;}

    previousRunSplit = runTime2Display - loadedGhost.raceTime;
    bestRunSplit = fastestRun2Display - loadedGhost.raceTime;
}



void GetGhost() {
#if TMNEXT
    if (recountGhosts && isPlayingOnline) return;
#endif

    if (UseDedimania()) {
#if MP4
        auto dataFileMgr = GetDataMgr();
        if (selectedIndex == -1) {
            if (GetApp().PlaygroundScript.ServerModeName == "CampaignSolo" && GetReplayRecord() !is null && (previousGhostName != GetReplayRecord().Nickname || autoDetectEnabled)) {loadedGhost = CreateGhost(GetReplayRecord());}
            else if (GetApp().PlaygroundScript.ServerModeName == "VersusReplay" && GetVersusReplayRecord() !is null && (previousGhostName != GetVersusReplayRecord().Nickname || autoDetectEnabled)) {loadedGhost = CreateGhost(GetVersusReplayRecord());}
            else if (autoDetectedGhost != -1 && dataFileMgr.Ghosts.Length != 0 && GetApp().PlaygroundScript.ServerModeName != "VersusReplay" && GetReplayRecord() is null && GetApp().Editor is null) {loadedGhost = CreateGhost(dataFileMgr.Ghosts[autoDetectedGhost]);}
            else if (GetFastestSessionTime() !is null) {loadedGhost = GetFastestSessionTime();}
        }
#elif TMNEXT
        if (selectedIndex == -1) {
            if (GetDownloadedRecord() !is null) {loadedGhost = CreateGhost(GetDownloadedRecord());}
            else if (GetTMNEXTPB() !is null) {loadedGhost = CreateGhost(GetTMNEXTPB());}
            else if (GetFastestSessionTime() !is null) {loadedGhost = GetFastestSessionTime();}
        }
#elif TURBO
        auto dataFileMgr = GetDataMgr();
        if (GetApp().PlaygroundScript.ServerModeName == "TMC_CampaignSolo") {
            if (selectedSTMIndex == -1 && selectedIndex == -1) {                
                int mapSTMIndex = Text::ParseInt(GetApp().Challenge.MapName) - 1;
                if (mapSTMIndex >= 0 && mapSTMIndex < 200 && Setting_STMCompare) {loadedGhost = CreateGhost(STMRecords[mapSTMIndex]);}
                else if (dataFileMgr.Ghosts.Length != 0 && GetTurboReplayRecord() !is null) {loadedGhost = CreateGhost(GetTurboReplayRecord());}
                else if (GetFastestSessionTime() !is null) {loadedGhost = GetFastestSessionTime();}
            }
        } else if (GetFastestSessionTime() !is null) {loadedGhost = GetFastestSessionTime();}
#endif
    } else {
        if (selectedDediIndex == -1 && selectedIndex == -1) {
#if MP4
            if (Setting_PrioritizeWRDedi && dediReplayCPs[2].Length > 0) {loadedGhost = CreateGhost(2);}
            else {
                if (dediReplayCPs[0].Length > 0) {loadedGhost = CreateGhost(0);}
                else if (dediReplayCPs[1].Length > 0) {loadedGhost = CreateGhost(1);}
                else if (GetFastestSessionTime() !is null) {loadedGhost = GetFastestSessionTime();}
            }
#elif TURBO
            if (GetFastestSessionTime() !is null) {loadedGhost = GetFastestSessionTime();}
#endif
        }
    }
}



#if MP4 || TURBO
CTrackManiaPlayer @GetPlayer() {
  auto playground = GetApp().CurrentPlayground;
  if (playground is null || playground.GameTerminals.Length != 1) {return null;}
  return cast<CTrackManiaPlayer>(playground.GameTerminals[0].ControlledPlayer);
}



#elif TMNEXT
CSmPlayer@ GetPlayer() {
  CSmArenaClient@ playground = cast<CSmArenaClient>(GetApp().CurrentPlayground);
  if (playground is null || playground.GameTerminals.Length != 1) {return null;}
  return cast<CSmPlayer>(playground.GameTerminals[0].ControlledPlayer);
}
#endif



#if MP4
CGameGhostScript @GetReplayRecord() {
    auto dataFileMgr = GetDataMgr();
    if (dataFileMgr.TaskResults.Length == 0) {return null;}
    for (uint i = 0; i < dataFileMgr.TaskResults.Length; i++) {
        CWebServicesTaskResult_GhostScript@ replay = cast<CWebServicesTaskResult_GhostScript>(dataFileMgr.TaskResults[i]);
        if (replay !is null && replay.Ghost !is null) {
            uint mapCPWithLaps = GetApp().RootMap.TMObjective_IsLapRace ? mapCheckpointCount * GetApp().RootMap.TMObjective_NbLaps : mapCheckpointCount;
            if (replay.Ghost.Result.Checkpoints.Length == mapCPWithLaps) {return replay.Ghost;}
        }
    }
    return null;
}
#endif



#if TMNEXT
CGameGhostScript@ GetDownloadedRecord() {
    if (GetApp().Network.ClientManiaAppPlayground is null) return null;
    auto dataFileMgr = GetApp().Network.ClientManiaAppPlayground.DataFileMgr;
    
    if (GetApp().PlaygroundScript !is null) {if (dataFileMgr.Ghosts.Length != 0) return dataFileMgr.Ghosts[dataFileMgr.Ghosts.Length - 1];}
    else {
        for (int i = dataFileMgr.Ghosts.Length - 1; i >= ghostCountStartTM2020; i--) {
            if (!dataFileMgr.Ghosts[i].Nickname.Contains('Personal best') && !dataFileMgr.Ghosts[i].Nickname.Contains(GetPlayerName())) return dataFileMgr.Ghosts[i];
        }
    }
    return null;
}



CGameGhostScript@ GetTMNEXTPB() {
    auto dataFileMgr = GetDataMgr();
    if (dataFileMgr.Ghosts.Length == 0) return null;
    for (int i = dataFileMgr.Ghosts.Length - 1; i >= ghostCountStartTM2020; i--) {
        if (dataFileMgr.Ghosts[i].Nickname.Contains('Personal best') && dataFileMgr.Ghosts[i].Result.Time != MAX_INT) return dataFileMgr.Ghosts[i];
    }
    return null;
}
#endif



CGameGhostStriped@ GetFastestSessionTime() {
    if (previousRunTimes.Length == 0) return null;
    vec2 fastestTime = vec2(MAX_INT, -1);
    for (uint i = 0; i < previousRunTimes.Length; i++) {
        if (previousRunTimes[i].raceTime < fastestTime.x) {fastestTime.x = previousRunTimes[i].raceTime; fastestTime.y = i;}
    }
    return fastestTime.y != -1 ? previousRunTimes[int(fastestTime.y)] : CGameGhostStriped();
}



int GetLocalPBRecord() {
#if TMNEXT
    return -1;
#elif MP4 || TURBO
    auto dataFileMgr = GetDataMgr();
    if (dataFileMgr.Ghosts.Length == 0) return -1;

    int detectedPB = -1;
    if (dataFileMgr.Ghosts.Length > 4) {detectedPB = 4;}
    else if (NameIsNotMedalOrPB(0)) {detectedPB = 0;} 

    for (uint i = 5; i < dataFileMgr.Ghosts.Length; i++) {
        if (GhostResult(i).Time == -1) continue;
        if (detectedPB == -1) detectedPB = i;
        if (GhostResult(i).Time < GhostResult(detectedPB).Time) detectedPB = i;
    }

    return GhostResult(detectedPB) !is null && GhostResult(detectedPB).Time != -1 ? detectedPB : -1;
#endif
}



#if MP4
CGameGhostScript @GetVersusReplayRecord() {
    auto dataFileMgr = GetDataMgr();
    if (dataFileMgr.TaskResults.Length == 0) {return null;}
    for (int i = dataFileMgr.TaskResults.Length - 1; i >= 0 ; i--) {
        CWebServicesTaskResult_GhostListScript@ replay = cast<CWebServicesTaskResult_GhostListScript>(dataFileMgr.TaskResults[i]);
        bool isReplayNotDriven = true;
        for (uint k = 0; k < previousRunTimes.Length; k++) {
            if (replay.Ghosts[0].Nickname.Contains(GetPlayerName()) && int(previousRunTimes[k].raceTime) == replay.Ghosts[0].Result.Time) {isReplayNotDriven = false;}
        }
        if (!replay.Ghosts[0].Nickname.Contains(GetPlayerName()) || isReplayNotDriven) {
            uint mapCPWithLaps = mapCheckpointCount;
            if (GetApp().RootMap.TMObjective_IsLapRace) mapCPWithLaps *= GetApp().RootMap.TMObjective_NbLaps;
            if (replay.Ghosts[0] !is null && replay.Ghosts[0].Result.Checkpoints.Length == mapCPWithLaps) {
                return replay.Ghosts[0];
            }
        }
    }
    return null;
}



uint[] GetScores() {
    uint[] records = {};
    auto scoreMgr = GetApp().PlaygroundScript.ScoreMgr;
    for (uint i = 0; i < scoreMgr.TaskResults.Length; i++) {
        CWebServicesTaskResult_GhostScript@ result = cast<CWebServicesTaskResult_GhostScript@>(scoreMgr.TaskResults[i]);
        if (result !is null && result.HasSucceeded && result.Ghost !is null && NameIsNotMedalOrPB(i, true)) {records.InsertLast(result.Ghost.Result.Time); return records;}
    }
    return records;
}
#endif



#if MP4 || TURBO
int GetPBIndex() {
    uint[] records = GetScores();
    auto dataFileMgr = GetDataMgr();
    if (dataFileMgr.Ghosts.Length == 0) return -1;
    for (uint i = 0; i < dataFileMgr.Ghosts.Length; i++) {
        if (NameIsNotMedalOrPB(i) && records.Find(GhostResult(i).Time) != -1) {return i;} 
    }
    return -1;
}
#endif



#if TURBO
uint[] GetScores() {
    uint[] records = {};
    auto dataFileMgr = GetDataMgr();
    for (uint i = 0; i < dataFileMgr.Records.Length; i++) records.InsertLast(dataFileMgr.Records[i].Time);
    return records;
}



CGameGhostScript @GetTurboReplayRecord() {
    auto dataFileMgr = GetDataMgr();
    if (dataFileMgr.Ghosts.Length == 0) return null;
    for (int i = dataFileMgr.Ghosts.Length - 1; i >= 0; i--) {
        if (NameIsNotMedalOrPB(i) && (!dataFileMgr.Ghosts[i].Nickname.Contains(GetPlayerName()) || i == GetPBIndex())) {return dataFileMgr.Ghosts[i];} 
    }
    uint mapCPWithLaps = mapCheckpointCount;
    if (GetApp().Challenge.TMObjective_IsLapRace) mapCPWithLaps *= GetApp().Challenge.TMObjective_NbLaps;
    if (dataFileMgr.Ghosts[0].RaceResult is null) return null;
    if (dataFileMgr.Ghosts[0].Nickname.Contains('Gold Medal') && dataFileMgr.Ghosts.Length >= 4 && dataFileMgr.Ghosts[3].RaceResult.Checkpoints.Length - 1 == mapCPWithLaps) return dataFileMgr.Ghosts[3];
    else if (dataFileMgr.Ghosts.Length < 3 && dataFileMgr.Ghosts[0].RaceResult.Checkpoints.Length == mapCPWithLaps) return dataFileMgr.Ghosts[0];
    
    return null;
}
#endif



bool NameIsNotMedalOrPB(int i, bool isScore = false) {
    auto dataFileMgr = GetDataMgr();
#if TMNEXT
    if (dataFileMgr.Ghosts.Length == 0) return false;
    if (dataFileMgr.Ghosts[i].Result is null) return false;
    return !dataFileMgr.Ghosts[i].Nickname.Contains('Personal best');
#endif

#if MP4
    if (GetApp().PlaygroundScript is null) return false;
    string name = '';
    if (isScore) {
        CWebServicesTaskResult_GhostScript@ result = cast<CWebServicesTaskResult_GhostScript@>(GetApp().PlaygroundScript.ScoreMgr.TaskResults[i]);
        name = result.Ghost.Nickname;
    } else {
        if (dataFileMgr.Ghosts.Length == 0) return false;
        if (dataFileMgr.Ghosts[i].Result is null) return false;
        name = dataFileMgr.Ghosts[i].Nickname;
    }

    return !name.Contains('Author Medal') &&
           !name.Contains('Gold Medal') &&
           !name.Contains('Silver Medal') &&
           !name.Contains('Bronze Medal');
#elif TURBO
    if (dataFileMgr.Ghosts[i].RaceResult is null) return false;
    return !dataFileMgr.Ghosts[i].Nickname.Contains('Gold Medal') &&
           !dataFileMgr.Ghosts[i].Nickname.Contains('Silver Medal') &&
           !dataFileMgr.Ghosts[i].Nickname.Contains('Bronze Medal');  
#endif
}



void RenderSplit(int currentSplit) {
#if MP4 || TMNEXT
    if (currentSplit > 0) {LeftPadding(Setting_PaddingWidth, "\\$s\\$" + GetManiaplanetColour(Setting_NegativeDelta) + "+" + formatSplit(Math::Abs(currentSplit)));}
    else if (currentSplit < 0) {LeftPadding(Setting_PaddingWidth, "\\$s\\$" + GetManiaplanetColour(Setting_PositiveDelta) + "-" + formatSplit(Math::Abs(currentSplit)));}
    else {LeftPadding(Setting_PaddingWidth, "\\$s\\$" + GetManiaplanetColour(Setting_EqualDelta) + "+0:00.000");}
#elif TURBO
    if (currentSplit > 0) {LeftPadding(Setting_PaddingWidth, "\\$s\\$f00+" + formatSplit(Math::Abs(currentSplit)));}
    else if (currentSplit < 0) {LeftPadding(Setting_PaddingWidth, "\\$s\\$03f-" + formatSplit(Math::Abs(currentSplit)));}
    else {LeftPadding(Setting_PaddingWidth, "\\$s\\$09f+0:00.000");}
#endif
}



#if TMNEXT || MP4
CTmRaceResultNod@ GhostResult(uint index) {
    return GetDataMgr().Ghosts.Length > index ? GetDataMgr().Ghosts[index].Result : null;
}
#elif TURBO
CTmRaceResultNod@ GhostResult(uint index) {
    return GetDataMgr().Ghosts.Length > index ? GetDataMgr().Ghosts[index].RaceResult : null;
}
#endif



/* 
    Methods for MP4 and turbo taken from the "Checkpoint Counter" plugin by Phlarx
    It has been modified to return the CP count on map launch
    Link to original: https://openplanet.dev/plugin/checkpointcounter
*/

int GetCPCount() {
#if TMNEXT
    auto playground = cast<CSmArenaClient>(GetApp().CurrentPlayground);
    MwFastBuffer<CGameScriptMapLandmark@> landmarks = playground.Arena.MapLandmarks;	
    int _maxCP = 0;
    
    array<int> links = {};
    for(uint i = 0; i < landmarks.Length; i++) {
        if(landmarks[i].Waypoint !is null && !landmarks[i].Waypoint.IsFinish && !landmarks[i].Waypoint.IsMultiLap) {
            if(landmarks[i].Tag == "Checkpoint") {
                _maxCP += 1;
            } else if(landmarks[i].Tag == "LinkedCheckpoint") {
                if(links.Find(landmarks[i].Order) < 0) {
                    _maxCP += 1;
                    links.InsertLast(landmarks[i].Order);
                }
            } else {_maxCP += 1;}
        }
    }
    return _maxCP + 1;
#elif MP4
    auto rootMap = GetApp().RootMap;
    int _maxCP = 0;

    array<int> links = {};
    for(uint i = 0; i < rootMap.Blocks.Length; i++) {
        if(rootMap.Blocks[i].WaypointSpecialProperty !is null && rootMap.Blocks[i].BlockInfo !is null) {
            auto tag = rootMap.Blocks[i].WaypointSpecialProperty.Tag;
            auto type = rootMap.Blocks[i].BlockInfo.WaypointType;
            if(type == CGameCtnBlockInfo::EWayPointType::Checkpoint) {
                // we have a CP, but we don't know if it is Linked or not
                if(tag == "Checkpoint" || tag == "Goal") {
                    _maxCP++;
                } else if(tag == "LinkedCheckpoint") {
                    if(links.Find(rootMap.Blocks[i].WaypointSpecialProperty.Order) < 0) {
                        _maxCP++;
                        links.InsertLast(rootMap.Blocks[i].WaypointSpecialProperty.Order);
                    }
                } else {_maxCP++;}
            }
        }
    }
    for(uint i = 0; i < rootMap.AnchoredObjects.Length; i++) {
        if(rootMap.AnchoredObjects[i].WaypointSpecialProperty !is null) {
            auto tag = rootMap.AnchoredObjects[i].WaypointSpecialProperty.Tag;
            auto type = rootMap.AnchoredObjects[i].ItemModel.WaypointType;
            if(type == CGameItemModel::EnumWaypointType::Checkpoint) {
                // we have a CP, but we don't know if it is Linked or not
                if(tag == "Checkpoint" || tag == "Goal") {
                    _maxCP++;
                } else if(tag == "LinkedCheckpoint") {
                    if(links.Find(rootMap.AnchoredObjects[i].WaypointSpecialProperty.Order) < 0) {
                        _maxCP++;
                        links.InsertLast(rootMap.AnchoredObjects[i].WaypointSpecialProperty.Order);
                    }
                } else {_maxCP++;}
            }
        }
    }
    return _maxCP + 1;
#elif TURBO
    if (GetApp().PlaygroundScript !is null) {
        auto playgroundScript = cast<CTrackManiaRaceRules>(GetApp().PlaygroundScript);
        if (playgroundScript.MapCheckpointPos.Length == 0) return MAX_INT;
        else return playgroundScript.MapCheckpointPos.Length + 1;
    }
    return MAX_INT;
#endif
}