dictionary drawDictionary = {
    { '0', Zero()},
    { '1', One()},
    { '2', Two()},
    { '3', Three()},
    { '4', Four()},
    { '5', Five()},
    { '6', Six()},
    { '7', Seven()},
    { '8', Eight()},
    { '9', Nine()}
};

class Character
{
    Character() {}
    void RenderChar(vec3 coords, vec3 colour, float scaler = 1) {}
}

class Zero : Character
{
    Zero() {}
    void RenderChar(vec3 coords, vec3 colour, float scaler = 1) override {Numbers::DrawZero(coords, colour, scaler);}
}

class One : Character
{
    One() {}
    void RenderChar(vec3 coords, vec3 colour, float scaler = 1) override {Numbers::DrawOne(coords, colour, scaler);}
}

class Two : Character
{
    Two() {}
    void RenderChar(vec3 coords, vec3 colour, float scaler = 1) override {Numbers::DrawTwo(coords, colour, scaler);}
}

class Three : Character
{
    Three() {}
    void RenderChar(vec3 coords, vec3 colour, float scaler = 1) override {Numbers::DrawThree(coords, colour, scaler);}
}

class Four : Character
{
    Four() {}
    void RenderChar(vec3 coords, vec3 colour, float scaler = 1) override {Numbers::DrawFour(coords, colour, scaler);}
}

class Five : Character
{
    Five() {}
    void RenderChar(vec3 coords, vec3 colour, float scaler = 1) override {Numbers::DrawFive(coords, colour, scaler);}
}

class Six : Character
{
    Six() {}
    void RenderChar(vec3 coords, vec3 colour, float scaler = 1) override {Numbers::DrawSix(coords, colour, scaler);}
}

class Seven : Character
{
    Seven() {}
    void RenderChar(vec3 coords, vec3 colour, float scaler = 1) override {Numbers::DrawSeven(coords, colour, scaler);}
}

class Eight : Character
{
    Eight() {}
    void RenderChar(vec3 coords, vec3 colour, float scaler = 1) override {Numbers::DrawEight(coords, colour, scaler);}
}

class Nine : Character
{
    Nine() {}
    void RenderChar(vec3 coords, vec3 colour, float scaler = 1) override {Numbers::DrawNine(coords, colour, scaler);}
}

namespace Numbers {
    void DrawString(const string &in stringToUse, vec3 position, vec3 colour, float scaler)
    {
        for (int i = 0; i < stringToUse.Length; i++) {
            string char = stringToUse.SubStr(i, 1);
            auto characterToRender = cast<Character>(drawDictionary[char]);
            if (characterToRender is null) continue;
            characterToRender.RenderChar(vec3(position.x - ((0.4 * scaler) * i), position.y, position.z), colour, scaler);
        }
    }

    void DrawZero(vec3 coords, vec3 colour, float scaler = 1)
    {
        DrawSquare(coords, vec3(0.10,0.70,0) * scaler, colour);
        DrawSquare(coords, vec3(0.30,0.10,0) * scaler, colour);
        DrawSquare(vec3((coords.x + (0.20 * scaler)), coords.y, coords.z), vec3(0.10,0.70,0) * scaler, colour);
        DrawSquare(vec3((coords.x), (coords.y + (0.60 * scaler)), coords.z), vec3(0.30,0.10,0) * scaler, colour);
    }

    void DrawOne(vec3 coords, vec3 colour, float scaler = 1)
    {
        DrawSquare(coords, vec3(0.30,0.10,0) * scaler, colour);
        DrawSquare(vec3((coords.x + (0.10 * scaler)), coords.y, coords.z), vec3(0.10,0.70,0) * scaler, colour);
        DrawSquare(vec3(coords.x + (0.10 * scaler), coords.y + (0.60 * scaler), coords.z), vec3(0.20,0.10,0) * scaler, colour);
    }

    void DrawTwo(vec3 coords, vec3 colour, float scaler = 1)
    {
#if MP4 || TMNEXT
    auto visState = VehicleState::GetVis(GetApp().GameScene, VehicleState::GetViewingPlayer()).AsyncState;
#elif TURBO
    auto visState = VehicleState::ViewingPlayerState();
#endif

        DrawSquare(coords, vec3(0.10,0.20,0) * scaler, colour);
        DrawSquare(coords, vec3(0.30,0.10,0) * scaler, colour);
        DrawSquare(vec3((coords.x + (0.20 * scaler)), coords.y, coords.z), vec3(0.10,0.20,0) * scaler, colour);
        DrawSquare(vec3(coords.x, coords.y + (0.60 * scaler), coords.z), vec3(0.30,0.10,0) * scaler, colour);
        DrawSquare(vec3(coords.x, coords.y + (0.50 * scaler), coords.z), vec3(0.10,0.20,0) * scaler, colour);
        DrawSquare(vec3(coords.x + (0.20 * scaler), coords.y + (0.50 * scaler), coords.z), vec3(0.10,0.20,0) * scaler, colour);

        DrawTriangle(Camera::ToScreenSpace(ProjectVerticeSpace(visState, vec3(coords.x + (0.20 * scaler), coords.y + (0.20 * scaler), coords.z))),  
                     Camera::ToScreenSpace(ProjectVerticeSpace(visState, vec3(coords.x, coords.y + (0.50 * scaler), coords.z))),
                     Camera::ToScreenSpace(ProjectVerticeSpace(visState, vec3(coords.x + (0.10 * scaler), coords.y + (0.50 * scaler), coords.z))), colour, 1);

        DrawTriangle(Camera::ToScreenSpace(ProjectVerticeSpace(visState, vec3(coords.x + (0.20 * scaler), coords.y + (0.20 * scaler), coords.z))),  
                     Camera::ToScreenSpace(ProjectVerticeSpace(visState, vec3(coords.x + (0.10 * scaler), coords.y + (0.50 * scaler), coords.z))),
                     Camera::ToScreenSpace(ProjectVerticeSpace(visState, vec3(coords.x + (0.30 * scaler), coords.y + (0.20 * scaler), coords.z))), colour, 1);
    }

    void DrawThree(vec3 coords, vec3 colour, float scaler = 1)
    {
        DrawSquare(coords, vec3(0.30,0.10,0) * scaler, colour);
        DrawSquare(vec3(coords.x + (0.20 * scaler), coords.y, coords.z), vec3(0.10,0.20,0) * scaler, colour);
        DrawSquare(vec3((coords.x + (0.10 * scaler)), coords.y + (0.30 * scaler), coords.z), vec3(0.20,0.10,0) * scaler, colour);
        DrawSquare(vec3((coords.x + (0.20 * scaler)), coords.y + (0.50 * scaler), coords.z), vec3(0.10,0.20,0) * scaler, colour);
        DrawSquare(vec3((coords.x), coords.y, coords.z), vec3(0.10,0.70,0) * scaler, colour);
        DrawSquare(vec3((coords.x), coords.y + (0.60 * scaler), coords.z), vec3(0.30,0.10,0) * scaler, colour);
    }

    void DrawFour(vec3 coords, vec3 colour, float scaler = 1)
    {
        DrawSquare(vec3(coords.x + (0.20 * scaler), coords.y + (0.30 * scaler), coords.z), vec3(0.10,0.40,0) * scaler, colour);
        DrawSquare(vec3(coords.x, coords.y, coords.z), vec3(0.10,0.70,0) * scaler, colour);
        DrawSquare(vec3(coords.x, coords.y + (0.30 * scaler), coords.z), vec3(0.30,0.10,0) * scaler, colour);
    }

    void DrawFive(vec3 coords, vec3 colour, float scaler = 1)
    {
        DrawSquare(coords, vec3(0.30,0.10,0) * scaler, colour);
        DrawSquare(coords, vec3(0.10,0.40,0) * scaler, colour);
        DrawSquare(vec3((coords.x + (0.10 * scaler)), coords.y + (0.30 * scaler), coords.z), vec3(0.20,0.10,0) * scaler, colour);
        DrawSquare(vec3((coords.x), coords.y + (0.50 * scaler), coords.z), vec3(0.10,0.20,0) * scaler, colour);
        DrawSquare(vec3((coords.x + (0.20 * scaler)), coords.y + (0.30 * scaler), coords.z), vec3(0.10,0.40,0) * scaler, colour);
        DrawSquare(vec3((coords.x), coords.y + (0.60 * scaler), coords.z), vec3(0.30,0.10,0) * scaler, colour);
    }

    void DrawSix(vec3 coords, vec3 colour, float scaler = 1)
    {
        DrawSquare(coords, vec3(0.30,0.10,0) * scaler, colour);
        DrawSquare(coords, vec3(0.10,0.40,0) * scaler, colour);
        DrawSquare(vec3((coords.x + (0.10 * scaler)), coords.y + (0.30 * scaler), coords.z), vec3(0.20,0.10,0) * scaler, colour);
        DrawSquare(vec3((coords.x), coords.y + (0.50 * scaler), coords.z), vec3(0.10,0.20,0) * scaler, colour);
        DrawSquare(vec3((coords.x + (0.20 * scaler)), coords.y, coords.z), vec3(0.10,0.70,0) * scaler, colour);
        DrawSquare(vec3((coords.x), coords.y + (0.60 * scaler), coords.z), vec3(0.30,0.10,0) * scaler, colour);
    }

    void DrawSeven(vec3 coords, vec3 colour, float scaler = 1)
    {
#if MP4 || TMNEXT
    auto visState = VehicleState::GetVis(GetApp().GameScene, VehicleState::GetViewingPlayer()).AsyncState;
#elif TURBO
    auto visState = VehicleState::ViewingPlayerState();
#endif

        DrawSquare(vec3(coords.x, coords.y + (0.50 * scaler), coords.z), vec3(0.10,0.20,0) * scaler, colour);
        DrawSquare(vec3(coords.x, coords.y + (0.60 * scaler), coords.z), vec3(0.30,0.10,0) * scaler, colour);
        DrawSquare(vec3((coords.x + (0.20 * scaler)), coords.y + (0.50 * scaler), coords.z), vec3(0.10,0.20,0) * scaler, colour);

        DrawTriangle(Camera::ToScreenSpace(ProjectVerticeSpace(visState, vec3(coords.x + (0.10 * scaler), coords.y + (0.50 * scaler), coords.z))),  
                     Camera::ToScreenSpace(ProjectVerticeSpace(visState, vec3(coords.x + (0.25 * scaler), coords.y, coords.z))),
                     Camera::ToScreenSpace(ProjectVerticeSpace(visState, vec3(coords.x + (0.15 * scaler), coords.y, coords.z))), colour, 1);

        DrawTriangle(Camera::ToScreenSpace(ProjectVerticeSpace(visState, vec3(coords.x + (0.10 * scaler), coords.y + (0.50 * scaler), coords.z))),  
                     Camera::ToScreenSpace(ProjectVerticeSpace(visState, vec3(coords.x + (0.15 * scaler), coords.y, coords.z))),
                     Camera::ToScreenSpace(ProjectVerticeSpace(visState, vec3(coords.x, coords.y + (0.50 * scaler), coords.z))), colour, 1);
    }

    void DrawEight(vec3 coords, vec3 colour, float scaler = 1)
    {
        DrawSquare(coords, vec3(0.10,0.70,0) * scaler, colour);
        DrawSquare(coords, vec3(0.30,0.10,0) * scaler, colour);
        DrawSquare(vec3((coords.x + (0.20 * scaler)), coords.y, coords.z), vec3(0.10,0.70,0) * scaler, colour);
        DrawSquare(vec3(coords.x, (coords.y + (0.60 * scaler)), coords.z), vec3(0.30,0.10,0) * scaler, colour);
        DrawSquare(vec3(coords.x, (coords.y + (0.30 * scaler)), coords.z), vec3(0.30,0.10,0) * scaler, colour);
    }

    void DrawNine(vec3 coords, vec3 colour, float scaler = 1)
    {
        DrawSquare(coords, vec3(0.30,0.10,0) * scaler, colour);
        DrawSquare(coords, vec3(0.10,0.70,0) * scaler, colour);
        DrawSquare(vec3((coords.x + (0.10 * scaler)), coords.y + (0.30 * scaler), coords.z), vec3(0.20,0.10,0) * scaler, colour);
        DrawSquare(vec3(coords.x + (0.20 * scaler), coords.y, coords.z), vec3(0.10,0.20,0) * scaler, colour);
        DrawSquare(vec3((coords.x + (0.20 * scaler)), coords.y + (0.30 * scaler), coords.z), vec3(0.10,0.40,0) * scaler, colour);
        DrawSquare(vec3(coords.x, coords.y + (0.60 * scaler), coords.z), vec3(0.30,0.10,0) * scaler, colour);
    }
}