// General Settings
[Setting name="Display Plugin" description="Chooses whether to display window or not." category="General"]
bool Setting_Enable = true;

[Setting name="Enable Lap Stats" description="Chooses whether to display lap stats on multilap track." category="General"]
bool Setting_EnableLapStats = true;

#if MP4
[Setting name="Enable Multiplayer" description="Chooses whether to display the plugin online." category="General"]
bool Setting_EnableMultiplayer = true;
#endif

[Setting name="Enable Notifications" description="Allows notifications after you change comparison replay or re-enable autodetect." category="General"]
bool Setting_EnableNotif = true;

[Setting name="Replay Change Quick Access" description="Adds change replay button on UI." category="General"]
bool Setting_QuickAccess = true;

[Setting name="Lock UI Position" description="Disables moving the UI by clicking and dragging." category="General" ]
bool Setting_LockUIPos = false;

[Setting name="UI Position" category="General" ]
vec2 Setting_UIPos = vec2(0, 0);

[Setting name="Font Size (Plugin Restart Required)" category="General"]
int Setting_FontSize = 16;

[Setting name="UI Padding Width" category="General" min=0 max=64 Slider]
int Setting_PaddingWidth = 0;


#if TURBO
[Setting name="Use STM Time" description="Compares splits to the STM time" category="STM"]
bool Setting_STMCompare = false;
#endif


// Holo settings
[Setting name="Enable HUD" description="Enable the HUD." category="HUD"]
bool Setting_EnableHUD = true;

[Setting name="Disable GUI When Enabled" description="Disables GUI interface and only renders the HUD." category="HUD"]
bool Setting_DisableGUIforHUD = false;

[Setting name="Enable Lines to Center" description="Chooses whether to display the lines on the holo HUD." category="HUD"]
bool Setting_EnableLineCenter = true;

[Setting name="Always Display Laps" description="Always show the lap count." category="HUD"]
bool Setting_AlwaysDisLaps = true;

[Setting name="Scale HUD in all Cameras" description="Scales HUD in all camera instead of just Cam 7." category="HUD"]
bool Setting_AlwaysScaleHUD = false;

[Setting name="Render Text in 3D Space" category="HUD"]
bool Setting_Render3D = true;

[Setting name="Show Example HUD" description="Show an example HUD to configure settings." category="HUD"]
bool Setting_EnableExHud = false;

[Setting name="Font Size" category="HUD"]
int Setting_FontSizeHUD = 18;

[Setting name="Font Size Scalable" category="HUD"]
int Setting_FontSizeHUDScalable = 80;

[Setting name="Display Time" description="Number of seconds the HUD is displayed after a CP." category="HUD" min=1 max=15]
int Setting_HUDDisplayTime = 5;

#if MP4
[Setting name="HUD Offset Laps Canyon" description="HUD spacing settings for canyon." category="HUD"]
vec3 Setting_CanyonHUDLaps = vec3(1.20, 0.9, 0);

[Setting name="HUD Offset Splits Canyon" description="HUD spacing settings for canyon." category="HUD"]
vec3 Setting_CanyonHUDSplits = vec3(-1.20, 0.9, 0);

[Setting name="HUD Offset Laps Valley" description="HUD spacing settings for valley." category="HUD"]
vec3 Setting_ValleyHUDLaps = vec3(1.40, 0.9, 0);

[Setting name="HUD Offset Splits Valley" description="HUD spacing settings for valley." category="HUD"]
vec3 Setting_ValleyHUDSplits = vec3(-1.40, 0.9, 0);

[Setting name="HUD Offset Laps Lagoon" description="HUD spacing settings for lagoon." category="HUD"]
vec3 Setting_LagoonHUDLaps = vec3(1.70, 0.9, 0);

[Setting name="HUD Offset Splits Lagoon" description="HUD spacing settings for lagoon." category="HUD"]
vec3 Setting_LagoonHUDSplits = vec3(-1.70, 0.9, 0);

[Setting name="HUD Offset Laps Stadium" description="HUD spacing settings for stadium." category="HUD"]
vec3 Setting_StadiumHUDLaps = vec3(1.10, 0.55, 0);

[Setting name="HUD Offset Splits Stadium" description="HUD spacing settings for stadium." category="HUD"]
vec3 Setting_StadiumHUDSplits = vec3(-1.10, 0.55, 0);

#elif TURBO
[Setting name="HUD Offset Laps Canyon" description="HUD spacing settings for canyon." category="HUD"]
vec3 Setting_CanyonHUDLaps = vec3(1.125, 0.75, 0);

[Setting name="HUD Offset Splits Canyon" description="HUD spacing settings for canyon." category="HUD"]
vec3 Setting_CanyonHUDSplits = vec3(-1.125, 0.75, 0);

[Setting name="HUD Offset Laps Valley" description="HUD spacing settings for valley." category="HUD"]
vec3 Setting_ValleyHUDLaps = vec3(1.20, 0.75, 0);

[Setting name="HUD Offset Splits Valley" description="HUD spacing settings for valley." category="HUD"]
vec3 Setting_ValleyHUDSplits = vec3(-1.20, 0.75, 0);

[Setting name="HUD Offset Laps Lagoon" description="HUD spacing settings for lagoon." category="HUD"]
vec3 Setting_LagoonHUDLaps = vec3(1.30, 0.5, 0);

[Setting name="HUD Offset Splits Lagoon" description="HUD spacing settings for lagoon." category="HUD"]
vec3 Setting_LagoonHUDSplits = vec3(-1.30, 0.5, 0);

[Setting name="HUD Offset Laps Stadium" description="HUD spacing settings for stadium." category="HUD"]
vec3 Setting_StadiumHUDLaps = vec3(1.10, 0.55, 0);

[Setting name="HUD Offset Splits Stadium" description="HUD spacing settings for stadium." category="HUD"]
vec3 Setting_StadiumHUDSplits = vec3(-1.10, 0.55, 0);

#elif TMNEXT
[Setting name="HUD Offset Laps" description="HUD offset for laps in stadium." category="HUD"]
vec3 Setting_Stadium2020HUDLaps = vec3(1.15, 0.55, 0);

[Setting name="HUD Offset Splits" description="HUD offset for splits for stadium." category="HUD"]
vec3 Setting_Stadium2020HUDSplits = vec3(-1.15, 0.55, 0);
#endif

[Setting name="Line Colour" description="Select a colour for the lines." category="HUD" color]
vec3 Setting_LineColour = vec3(0, 0, 0);

#if MP4
// Dedimania Settings
[Setting name="Enable Dedimania in Single Player" description="Enables online records to be used as comparison offline." category="Dedimania" color]
bool Setting_DediSoloEnable = true;

[Setting name="Prioritize Dedimania Offline" description="Prioritizes dedimania records over local records." category="Dedimania" color]
bool Setting_PrioritizeDediOffline = true;

[Setting name="Prioritize Offline Except on Nadeo Tracks" description="Prioritizes dedimania records only on non-Nadeo tracks." category="Dedimania" color]
bool Setting_PrioritizeDediOfflineNadeo = true;

[Setting name="Prioritize WR Record" description="Selects WR dedi over your own." category="Dedimania" color]
bool Setting_PrioritizeWRDedi = false;
#endif

// Colour Settings
[Setting name="Positive Delta" description="Colour for the positive splits." category="Colour" color]
vec3 Setting_PositiveDelta = vec3(0, 0.2, 1);

[Setting name="Negative Delta" description="Colour for the negative splits." category="Colour" color]
vec3 Setting_NegativeDelta = vec3(0.94, 0, 0);

[Setting name="Equal Delta" description="Colour for the equal splits." category="Colour" color]
vec3 Setting_EqualDelta = vec3(0, 0.57, 0.94);

[Setting name="Lap/Position" description="Colour for the lap/position counter." category="Colour" color]
vec3 Setting_LapCountColour = vec3(1, 1, 0);

[Setting name="Notification Colour" description="Colour for the notifications." category="Colour" color]
vec3 Setting_NotificationColour = vec3(0.05, 0.05, 0.05);

// Session Replay List
[Setting name="UI X Size" description="Set the X length of the UI." category="Session Replay List" min=300 max=1500 drag]
uint Setting_SizeX = 350;

[Setting name="UI Y Size" description="Set the Y length of the UI." category="Session Replay List" min=200 max=1000 drag]
uint Setting_SizeY = 500;

[Setting name="Include Downloaded Times" description="Gives the ability to save downloaded times from the leaderboards." category="Session Replay List"]
bool Setting_IncDownloadedTimes = true;

[Setting name="Include Medal Times" description="Gives the ability to save medal times if available." category="Session Replay List"]
bool Setting_IncMedalTimes = true;
